%{!?__id_u: %define __id_u /bin/id -u}

%define init_in_postinstall 0

Summary:	Watch for changes between RPM database and actual system
Name:		check-packages
Version:	1.1
Release:	4
License:	GPL
Group:		Applications/System
URL:		ftp://ftp.kaybee.org/pub/linux/
Source0:	ftp://ftp.kaybee.org/pub/linux/check-packages-1.1
Source1:	check-packages.init
Patch0:		check-packages-1.1-sort.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service

%description
This package keeps track of differences between the RPM database
and the actual files installed on your system.  It checks every
night for any changes in these differences.

%prep
%setup -c -n check-packages -T
%{__sed} -e 's@/var/local/@%{_localstatedir}/lib/@' \
	 -e 's@unalias .*@& \&> /dev/null@' %{SOURCE0} > check-packages
%patch0 -p0
%{__cat} > check-packages.cron << EOF
#!/bin/sh

[ -f /var/lock/subsys/check-packages ] && %{_sbindir}/check-packages
EOF

%install
[ "%{buildroot}" != "/" -a -n "%{buildroot}" ] && %{__rm} -rf "%{buildroot}"
%{__install} -d -m 0755 %{buildroot}%{_sbindir}
%{__install} -d -m 0755 %{buildroot}%{_sysconfdir}/cron.daily
%{__install} -d -m 0700 %{buildroot}%{_localstatedir}/lib/check-packages
%{__install} -d -m 0755 %{buildroot}%{_initrddir}
%{__install} -m 0755 check-packages %{buildroot}%{_sbindir}
%{__install} -m 0755 check-packages.cron %{buildroot}%{_sysconfdir}/cron.daily
: > %{buildroot}%{_localstatedir}/lib/check-packages/rpmqa
: > %{buildroot}%{_localstatedir}/lib/check-packages/rpmva
%{__install} -m 0755 %{SOURCE1} %{buildroot}%{_initrddir}/check-packages

%clean
[ "%{buildroot}" != "/" -a -n "%{buildroot}" ] && %{__rm} -rf "%{buildroot}"

%post
/sbin/chkconfig --add check-packages
%if %{init_in_postinstall}
if [ ! -s %{_localstatedir}/lib/check-packages/rpmqa ]; then
	echo "Initializing database #1, please wait... (running rpm -qa)"
	/bin/rpm -qa > %{_localstatedir}/lib/check-packages/rpmqa || :
fi
if [ ! -s %{_localstatedir}/lib/check-packages/rpmva ]; then
	echo "Initializing database #2, please wait... (running rpm -Va)"
	echo "(this one will take a while)"
	/bin/rpm -Va > %{_localstatedir}/lib/check-packages/rpmva || :
fi
%endif
# Fix unsorted files
cd %{_localstatedir}/lib/check-packages
[ -f rpmqa ] && LC_ALL=C /bin/sort -o rpmqa                 rpmqa || :
[ -f rpmva ] && LC_ALL=C /bin/sort -o rpmva -t '\0' -k 1.13 rpmva || :

%preun
if [ $1 = 0 ]; then
	/sbin/service check-packages stop &> /dev/null
        /sbin/chkconfig --del check-packages
fi

%files
%defattr(-,root,root,0755)
%attr(0700,root,root) %dir %{_localstatedir}/lib/check-packages
%ghost %{_localstatedir}/lib/check-packages/rpmqa
%ghost %{_localstatedir}/lib/check-packages/rpmva
%{_sbindir}/check-packages
%{_sysconfdir}/cron.daily/check-packages.cron
%{_initrddir}/check-packages

%changelog
* Fri Aug 19 2005 Paul Howarth <paul@city-fan.org> 1.1-4
- sort database files for neater/less output

* Mon Jul 25 2005 Paul Howarth <paul@city-fan.org> 1.1-3
- started changelog
- rewrote spec file
